;===========================================================================================
; directxproc.asm    Nasm assembler  AsmGges France             http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Cration d'une surface
;-------------------------------------------------------------------------------------------
; AdrSurface = adresse de la variable qui va contenir l'adresse de la surface cre
; LSurface   = largeur de la surface en pixels
; HSurface   = hauteur de la surface en pixels
;===========================================================================================
proc CreateSurf, AdrSurface, LSurface, HSurface

    call ZeroMemory,ddsd,DDSURFACEDESC_size
    mov D[ddsd+DDSURFACEDESC.dwSize],DDSURFACEDESC_size
    mov D[ddsd+DDSURFACEDESC.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
    mov D[ddsd+DDSURFACEDESC.ddsCaps],DDSCAPS_OFFSCREENPLAIN
    mov eax,[@LSurface]
    mov [ddsd+DDSURFACEDESC.dwWidth],eax
    mov eax,[@HSurface]
    mov [ddsd+DDSURFACEDESC.dwHeight],eax
    ddcall DD_CreateSurface,[DDraw],ddsd,[@AdrSurface],0

endproc
;===========================================================================================
; Remplir une surface avec une couleur
;-------------------------------------------------------------------------------------------
; NumSurf = [Nom] Surface  remplir
; Color   = couleur de remplissage format RGB 000000h
;===========================================================================================
proc FillSurface, NumSurf, Color

    call ZeroMemory,ddbltfx,DDBLTFX_size
    mov D[ddbltfx+DDBLTFX.dwSize],DDBLTFX_size
    mov eax,[@Color]
    mov [ddbltfx+DDBLTFX.dwFillColor],eax
    ddcall DDS_Blt,[@NumSurf],0,0,0,DDBLT_COLORFILL+DDBLT_WAIT,ddbltfx
    
endproc
;===========================================================================================
; Flip surface Back => surface Primary (Window Mode)
;===========================================================================================
FlipBackWinMode:
    invoke GetWindowRect,[hWin],rect2

    mov D[rect1+RECT.left],0
    mov D[rect1+RECT.top],0
    mov D[rect1+RECT.right],WSCREEN
    mov D[rect1+RECT.bottom],HSCREEN

    mov eax,[rect2+RECT.left]
    add eax,WSCREEN
    mov [rect2+RECT.right],eax

    mov eax,[rect2+RECT.top]
    add eax,[HBarTitle]
    mov [rect2+RECT.top],eax

    add eax,HSCREEN
    mov [rect2+RECT.bottom],eax
    ddcall DDS_Blt,[Primary],rect2,[Back],rect1,DDBLT_WAIT,0

    ret
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================